
/* constante 8 bits dans acc */
#define MOVACC(a) movi (a) & $F ; movih ((a) >> 4) & $F

/* clc */
#define CLC xora 0

/* mise d'une adresse dans r0 r1 */

#define MOVADR(adr) \
	MOVACC( adr & $FF ) ; movr 0 ; \
	MOVACC( ((adr)  >> 8) & $FF ) ; movr 1

#define LDMEM(reg,adr) MOVADR(adr) ; ldmem ; movr (reg) 
#define STMEM(reg,adr) MOVADR(adr) ; mova (reg) ; stmem

/* sauts conditonnels */

#define JC(adr)  movi ((adr)-@-3) & $F ; movih (((adr)-@-2) >> 4) & $F ; jc
#define JNC(adr)  movi ((adr)-@-3) & $F ; movih (((adr)-@-2) >> 4) & $F ; jnc
#define JZ(adr)  movi ((adr)-@-3) & $F ; movih (((adr)-@-2) >> 4) & $F ; jz
#define JNZ(adr)  movi ((adr)-@-3) & $F ; movih (((adr)-@-2) >> 4) & $F ; jnz

/* saut inconditionnel */
#define JMP(adr) MOVADR(adr) ; stpc

/* CALL de 1 niveau */
#define CALL(adr)  ldpc ; mova 0 ; movr 2 ; mova 1 ; movr 3 ; JMP(adr)

/* sauvegarde ret */
#define SAVERET(n) CLC ; MOVACC(12) ; addr 2 ; movi 0 ; addr 3 ; STMEM(2,retl##n) ; STMEM(3,reth##n)

/* retour procdure */
#define RET(n)       LDMEM(2,retl##n) ; LDMEM(1,reth##n) ; mova 2 ; movr 0 ; stpc 


#define STIM(imm,adr) MOVADR(adr) ; MOVACC(imm) ; stmem

#define STIM2(imm,adr)  STIM( (imm) & $FF, adr ) ; STIM( (imm) >> 8, adr + 1)


/* adressage index */

#define LDMEMI(reg,adr,regi) \
  MOVADR(adr) ; CLC ; mova regi ; addr 0 ; movi 0 ; addr 1 ; ldmem ; movr reg

#define STMEMI(reg,adr,regi) \
  MOVADR(adr) ; CLC ; mova regi ; addr 0 ; movi 0 ; addr 1 ; mova reg ; stmem

/* gestion priphriques */

#define AFFSEL 4
#define AFFLED 5
#define KBD    6
