#include "macro.S"

#define STACKSIZE 16

/* dbut du programme */

	STIM(0,stackptr)
	
/* affichage du niveau 0 de la pile / attente de la pression d'une touche  */

calc_loop:

	LDMEM(2,stackptr)
	MOVADR(stack)
	CLC
	mova 2
	addr 0
	movi 0
	addr 1
	ldmem
	movr 3
	STMEM(3,dec_aff0)
	
	MOVADR(stack+1)
	CLC
	mova 2
	addr 0
	movi 0
	addr 1
	ldmem
	movr 3
	STMEM(3,dec_aff1)
	
	LDMEM(2,dec_aff0)
	STMEM(2,baff0)
	LDMEM(2,dec_aff1)
	STMEM(2,baff1)
	
  CALL(convert_10)
	
	CALL(affichage)
	
	CALL(convert_key)
	
  LDMEM(2,touche)
	CLC
	MOVACC(9)
	subr 2
	JNC(enter_num)

  JMP(do_commande)

enter_num:

  STIM(10,acc_0)
	LDMEM(2,touche)
	STMEM(2,acc_2)
	LDMEM(2,dec_aff0)
	STMEM(2,acc_1)
	CALL(mul8)
	LDMEM(2,acc_1)
	STMEM(2,dec_aff0)
	LDMEM(2,dec_aff1)
	STMEM(2,acc_1)
	CALL(mul8)
	LDMEM(2,acc_1)
	STMEM(2,dec_aff1)
	

/* sauvegarde du nombre sur la pile */
save_dec_aff:
  LDMEM(3,dec_aff0)
	LDMEM(2,stackptr)
	MOVADR(stack)
	CLC
	mova 2
	addr 0
	movi 0
	addr 1
	mova 3
	stmem

	
  LDMEM(3,dec_aff1)
  MOVADR(stack+1)
	CLC
	mova 2
	addr 0
	movi 0
	addr 1
	mova 3
	stmem

  JMP(calc_loop)
	

do_commande:

	LDMEM(2,touche)
	MOVACC($D)
	xora 2
	JNZ(cmd_10)
	
  /* Enter */
	
  LDMEM(2,stackptr)
	CLC
	movi 2
	addr 2
	MOVACC(STACKSIZE-1)
	andr 2
	STMEM(2,stackptr)

	
	JMP(calc_loop)
	
	
cmd_10:
	MOVACC($E)
	xora 2
	JNZ(cmd_20)

  /* Drop */
	
	LDMEM(2,stackptr)
	CLC
	movi $E
	addr 2
	MOVACC(STACKSIZE-1)
	andr 2
	STMEM(2,stackptr)

	JMP(calc_loop)
	
cmd_20: 
	MOVACC($F)
	xora 2
	JNZ(cmd_30)
	
	/* Clear */
	
	STIM(0,dec_aff0)
	STIM(0,dec_aff1)
	
	JMP(save_dec_aff)
	
cmd_30:
  /* oprateurs binaires : on va chercher l'autre oprande */
  
  /* Drop */
	
  LDMEM(2,stackptr)
	CLC
	movi $E
	addr 2
	MOVACC(STACKSIZE-1)
	andr 2
	STMEM(2,stackptr)

  /* opa */

	LDMEM(2,stackptr)
	MOVADR(stack)
	CLC
	mova 2
	addr 0
	movi 0
	addr 1
	ldmem
	movr 3
	STMEM(3,opb0)
	
	MOVADR(stack+1)
	CLC
	mova 2
	addr 0
	movi 0
	addr 1
	ldmem
	movr 3
	STMEM(3,opb1)
	
	LDMEM(2,touche)
	MOVACC($A)
	xora 2
	JNZ(cmd_50)
		
  /* Commande + */

  CALL(do_add)
	
	JMP(save_dec_aff)

cmd_50:
  MOVACC($B)
	xora 2
	JNZ(cmd_60)
		
  /* Commande - */

  CALL(do_sub)
	
	JMP(save_dec_aff)
	
cmd_60: 
	
	
	/* mode tendu */
	
	LDMEM(2,data_led)
	STMEM(2,aff0)
	LDMEM(2,data_led+1)
	STMEM(2,aff1)
	LDMEM(2,data_led+2)
	STMEM(2,aff2)
	LDMEM(2,data_led+3)
	STMEM(2,aff3)
	LDMEM(2,data_led+4)
	STMEM(2,aff4)
	LDMEM(2,data_led+5)
	STMEM(2,aff5)
		
	CALL(affichage)
	
	CALL(convert_key)
	
	LDMEM(2,touche)
	MOVACC($A)
	xora 2
	JNZ(cmd_100)

  /* Commande * */

  CALL(do_mul)
	
	JMP(save_dec_aff)
		
cmd_100:
	MOVACC($B)
	xora 2
	JNZ(cmd_110)

  /* Commande / */

  CALL(do_div)
	
	JMP(save_dec_aff)

cmd_110:

	JMP(joke)



/*
 * Commande "+"
 */

do_add: 

  SAVERET(0)

	LDMEM(2,dec_aff0)
	LDMEM(3,opb0)
	CLC
	mova 3
	addr 2
	STMEM(2,dec_aff0)
	
	LDMEM(2,dec_aff1)
	LDMEM(3,opb1)
	mova 3
	addr 2
	STMEM(2,dec_aff1)
	
	RET(0)


/*
 * Commande "-"
 */

do_sub: 

  SAVERET(0)

	LDMEM(2,dec_aff0)
	LDMEM(3,opb0)
	CLC
	movi $F
	movr 0
	adda 0
	mova 2
	subr 3
	STMEM(3,dec_aff0)
	
	LDMEM(2,dec_aff1)
	LDMEM(3,opb1)
	mova 2
	subr 3
	STMEM(3,dec_aff1)
	
	RET(0)

/*
 * Mutiplication 16 bits
 */
 
do_mul:
	
	SAVERET(0)
	
	LDMEM(2,opb0)
	STMEM(2,acc_1)
	
	STIM(0,acc_2)
	
	LDMEM(2,dec_aff0)
	STMEM(2,acc_0)
	
	CALL(mul8)
	
	LDMEM(2,acc_1)
	STMEM(2,dec_aff0)
	
	LDMEM(2,opb1)
	STMEM(2,acc_1)
	
	CALL(mul8)
	
	LDMEM(2,acc_1)
	STMEM(2,acc_2)
	
	LDMEM(2,dec_aff1)
	STMEM(2,acc_1)
	
	LDMEM(2,opb0)
	STMEM(2,acc_0)
	
	CALL(mul8)
	
	LDMEM(2,acc_1)
	STMEM(2,dec_aff1)
	
	
	RET(0)
	
/* 
 * division (par un nombre de 8 bits )
 */
 
do_div:
	SAVERET(0)
	
	STIM(0,acc_2)

	LDMEM(2,opb1)
	STMEM(2,acc_1)
	
	LDMEM(2,dec_aff0)
	STMEM(2,acc_0)
	
	CALL(div8)
	
	LDMEM(2,acc_1)
	STMEM(2,dec_aff1)
	
	LDMEM(2,opb0)
	STMEM(2,acc_1)
	
	CALL(div8)
	
	LDMEM(2,acc_1)
	STMEM(2,dec_aff0)
	
	RET(0)
	
	
joke:
	LDMEM(2,data_joke)
	STMEM(2,aff0)
	LDMEM(2,data_joke+1)
	STMEM(2,aff1)
	LDMEM(2,data_joke+2)
	STMEM(2,aff2)
	LDMEM(2,data_joke+3)
	STMEM(2,aff3)
	LDMEM(2,data_joke+4)
	STMEM(2,aff4)
	LDMEM(2,data_joke+5)
	STMEM(2,aff5)

joke_loop:
	CALL(affichage)
	

	LDMEM(3,aff5)
	LDMEM(2,aff4)
	STMEM(2,aff5)
	LDMEM(2,aff3)
	STMEM(2,aff4)
	LDMEM(2,aff2)
	STMEM(2,aff3)
	LDMEM(2,aff1)
	STMEM(2,aff2)
	LDMEM(2,aff0)
	STMEM(2,aff1)
	STMEM(3,aff0)

  JMP(joke_loop)
	

data_joke:
 dbled 'F'
 dbled 'A'
 dbled 'B'
 dbled 'S'
 dbled 'Y'
 dbled 'L'

data_led:
 dbled '-'
 dbled 'S'
 dbled 'H'
 dbled 'I'
 dbled 'F'
 dbled 'T'

opb0:
	db 0
opb1:
	db 0

dec_aff0:
	db 0
dec_aff1:
	db 0

stackptr:
	db 0

stack:
	db 0 ; db 0
	db 0 ; db 0     
	db 0 ; db 0
	db 0 ; db 0
	db 0 ; db 0
	db 0 ; db 0
	db 0 ; db 0
	db 0 ; db 0


/* adresse de retour procdure */

retl0:
 db 0
reth0:
 db 0
 
retl1:
 db 0
reth1:
 db 0
	

#include "muldiv.S"

#include "cvt10.S"

#include "affkey.S"

end

