#include "macro.S"

#define SERIE1  $40
#define SERIE0  $00

#define LABY_MUR '*'
#define LABY_VIDE ' '
#define LABY_MONSTRE 'M'
#define LABY_SORTIE 'S'
#define LABY_MOI    'V'
#define LABY_CHEMIN '.'

debut:
	
	/* affichage du titre */
	
	STIM2(msg_laby,msg_strl)
	CALL(convert_msg)
	CALL(affichage)
	
	
	/* init */
	STIM($11,pos_cur)
	STIM2(0,penalitel)
	
	/* on y va: boucle principale */

laby_loop:
	
	/* affichage position */

  STIM2(msg_pos,msg_strl)
	CALL(convert_msg)

	LDMEM(2,pos_cur)
	CLC
	mova 2
	addr 2
	mova 2
	addr 2
	mova 2
	addr 2
	mova 2
	addr 2
	mova 2
	addr 2
	MOVACC($F)
	andr 2
  LDMEMI(2,tab_hex,2)
	STMEM(2,aff1)

  LDMEM(2,pos_cur)
	MOVACC($F)
	andr 2
  LDMEMI(2,tab_hex,2)
	STMEM(2,aff5)
	
	CALL(affichage) 

	CALL(convert_key)
	
	/* test touche */
	
	LDMEM(2,touche)
	
	MOVACC($2)
	xora 2
	JNZ(cmd_10)

  /* haut */
	
  LDMEM(2,pos_cur)
	CLC
	MOVACC(256-16)
	addr 2
	STMEM(2,pos_new)

	JMP(test_new)
	
cmd_10:
	MOVACC($8)
	xora 2
	JNZ(cmd_20)
	
	/* bas */
	
	LDMEM(2,pos_cur)
	CLC
	MOVACC(16)
	addr 2
	STMEM(2,pos_new)

	JMP(test_new)
	
cmd_20:
	MOVACC($4)
	xora 2
	JNZ(cmd_30)
	
	/* gauche */
	
	LDMEM(2,pos_cur)
	CLC
	MOVACC(256-1)
	addr 2
	STMEM(2,pos_new)

	JMP(test_new)

cmd_30:
	MOVACC($6)
	xora 2
	JNZ(cmd_40)
	
	/* droite */
	
	LDMEM(2,pos_cur)
	CLC
	MOVACC(1)
	addr 2
	STMEM(2,pos_new)

	JMP(test_new)

cmd_40:
	MOVACC($A)
	xora 2
	JNZ(cmd_50)
	
	STIM2(msg_triche,msg_strl)
	CALL(convert_msg)
	CALL(affichage_delai)
	
	JMP(do_triche)
	
cmd_50:
	MOVACC($0)
	xora 2
	JNZ(cmd_60)
	
  /* prsentation du programme */

  JMP(do_scroll)

cmd_60:
	JMP(laby_loop)


test_new:
	
	LDMEM(2,pos_new)
	LDMEMI(2,laby_plan,2)
	
	MOVACC(LABY_MUR)
	xora 2
	JNZ(testn_10)
	
	/* cas d'un mur */
	
	STIM2(msg_mur,msg_strl)
	CALL(convert_msg)
	CALL(affichage_delai)
	
  /* penalite + 1 */
  LDMEM(2,penalitel)
	CLC
	movi 1
	addr 2
	STMEM(2,penalitel)
	
	LDMEM(2,penaliteh)
	movi 0
	addr 2
	STMEM(2,penaliteh)

  JMP(laby_loop)

testn_10:
	
	MOVACC(LABY_MONSTRE)
	xora 2
	JNZ(testn_20)
	
	/* cas d'un monstre */
	
	STIM2(msg_monstre,msg_strl)
	CALL(convert_msg)
	CALL(affichage_delai)

  /* penalite + 5 */
  LDMEM(2,penalitel)
	CLC
	movi 5
	addr 2
	STMEM(2,penalitel)
	
	LDMEM(2,penaliteh)
	movi 0
	addr 2
	STMEM(2,penaliteh)


  JMP(laby_loop)
	
testn_20:
	MOVACC(LABY_SORTIE)
	xora 2
	JNZ(testn_100)
	
	/* cas de la sortie */
	JMP(do_sortie)


testn_100:

  /* case vide: on dplace en marquant le chemin */

	LDMEM(2,pos_cur)
	MOVACC(LABY_CHEMIN)
	movr 3
	STMEMI(3,laby_plan,2)
	
  LDMEM(2,pos_new)
	STMEM(2,pos_cur)

	MOVACC(LABY_MOI)
	movr 3
	STMEMI(3,laby_plan,2)

	JMP(laby_loop)
	

/*
 * traitement de la sortie
 */
 
do_sortie:
	STIM2(msg_sortie,msg_strl)
	CALL(convert_msg)
	CALL(affichage_delai)

	STIM2(msg_malus,msg_strl)
	CALL(convert_msg)
	CALL(affichage_delai)
	
	LDMEM(2,penalitel)
	STMEM(2,baff0)
	LDMEM(2,penaliteh)
	STMEM(2,baff1)
	
	CALL(convert_10)
	CALL(affichage)

  JMP(debut)
	

/*
 * Mode tricherie : envoi du plan du labyrithe sur un terminal vt52
 */
 
triche_idx:
	db 0

triche_str:
	db $0D,$0A,"Tricher c'est mal...",$0D,$0A
	db "Mais voici le plan:",$0D,$0A,$0D,$0A 
	db " M = Monstre",$0D,$0A
	db " S = Sortie",$0D,$0A
	db " V = Vous",$0D,$0A
	db " . = Partie exploree",$0D,$0A
	db 0

do_triche:
	STIM2(triche_str,send_strl)
	CALL(send_string)
	
	STIM(0,triche_idx)

triche_1:
	LDMEM(2,triche_idx)
	LDMEMI(2,laby_plan,2)
	STMEM(2,sendch)
	
	CALL(send_char)
	
	LDMEM(2,triche_idx)
	CLC
	movi 1
	addr 2
	STMEM(2,triche_idx)
	
	MOVACC($F)
	anda 2
	JNZ(triche_2)
	
	STIM($0D,sendch)
	CALL(send_char)
	STIM($0A,sendch)
	CALL(send_char)
	
triche_2:
	
	LDMEM(2,triche_idx)
	JZ(triche_fin)
	JMP(triche_1)

triche_fin:
	JMP(laby_loop)
	

/*
 * Affichage "Banner"
 */

#define SCROLL_LEN 73

msg_scroll:
	dbled "CE PROGRAMME A ETE CONCU ET REALISE PAR FABRICE BELLARD ET SYLVAIN DELA"
	db $12
	dbled "      "
	
do_scroll:

scroll_loop2:
	STIM(SCROLL_LEN,scroll_nb)
	STIM2(msg_scroll,scroll_l)

scroll_loop1:
	LDMEM(2,scroll_l)
	STMEM(2,msg_strl)
	LDMEM(2,scroll_h)
	STMEM(2,msg_strh)

	CALL(convert_msg)
	CALL(affichage_delai)
	
	LDMEM(2,scroll_l)
	CLC
	movi 1
	addr 2
	STMEM(2,scroll_l)
	
	LDMEM(2,scroll_h)
	CLC
	movi 0
	addr 2
	STMEM(2,scroll_h)

	LDMEM(2,scroll_nb)
	CLC
	movi $F
	addr 2
	STMEM(2,scroll_nb)
	JNZ(scroll_loop1)
	
  JMP(scroll_loop2)

scroll_l:
	db 0
scroll_h:
	db 0
scroll_nb:
	db 0
	
/* variables globales pour le jeu */

penalitel:
	db 0
penaliteh:
	db 0

pos_cur:
	db 0
pos_new:
	db 0
	


/* messages */

msg_laby:
	dbled "-LABY-"

msg_pos:
	dbled "L0--C0"

msg_mur:
	dbled " MUR  "
	
msg_monstre:
	dbled " AIE  "
	
msg_sortie:
	dbled "SORTIE"

msg_triche:
	dbled "TRICHE"
	
msg_malus:
	dbled "MALUS "

tab_hex:
 dbled '0'
 dbled '1'
 dbled '2'
 dbled '3'
 dbled '4'
 dbled '5'
 dbled '6'
 dbled '7'
 dbled '8'
 dbled '9'
 dbled 'A'
 dbled 'B'
 dbled 'C'
 dbled 'D'
 dbled 'E'
 dbled 'F'



/*
 * mise en place d'un message stock  l'adresse: msg_strl
 */
convert_msg:
	
	SAVERET(0)
	
	LDMEM(2,msg_strl)
	LDMEM(3,msg_strh)
	
  mova 2
	movr 0
	mova 3
	movr 1
	ldmem
	movr 5
	STMEM(5,aff0)
	CLC
	movi 1
	addr 2
	movi 0
	addr 3
	
  mova 2
	movr 0
	mova 3
	movr 1
	ldmem
	movr 5
	STMEM(5,aff1)
	CLC
	movi 1
	addr 2
	movi 0
	addr 3

  mova 2
	movr 0
	mova 3
	movr 1
	ldmem
	movr 5
	STMEM(5,aff2)
	CLC
	movi 1
	addr 2
	movi 0
	addr 3

  mova 2
	movr 0
	mova 3
	movr 1
	ldmem
	movr 5
	STMEM(5,aff3)
	CLC
	movi 1
	addr 2
	movi 0
	addr 3

  mova 2
	movr 0
	mova 3
	movr 1
	ldmem
	movr 5
	STMEM(5,aff4)
	CLC
	movi 1
	addr 2
	movi 0
	addr 3

  mova 2
	movr 0
	mova 3
	movr 1
	ldmem
	movr 5
	STMEM(5,aff5)

	RET(0)

msg_strl:
	db 0
msg_strh:
	db 0


retl0:
	db 0
reth0:
	db 0
retl1:  
	db 0
reth1:
	db 0
retl2:  
	db 0
reth2:
	db 0



laby_plan:

#include "labyplan.S"

#include "serial.S"

#include "muldiv.S"

#include "cvt10.S"

#include "affkey.S"

end

